setwd("D://Weihua_China//Paper1//SIMPaper//SIM_Code//SIM/")


rm(list=ls())

source("fun.R")

propdata<-read.csv(file="PropData.csv")
propdata<-as.matrix(propdata)

id=propdata[,1]
id_unique=unique(id);nsub=length(id_unique)
nk<-rep(0,nsub);

for (j in 1:nsub) nk[j]=sum(id==id_unique[j])

cn = c(0, cumsum(nk));
n=sum(nk)


### one continuous variable: AGE
x1=propdata[,5]


w=propdata[,2]
w1=1*(w==1);w2=1*(w==2);w3=1*(w==3)

z=propdata[,c(4,6,7)];z=cbind(z,w1,w2,w3)


y=propdata[,3];y=as.matrix(y);


############# Cubic B-spline with two interior knots ###########

N=2;p=4;J=N+p

ul=x1  
kl=seq(min(ul),max(ul),length=N+2)
kl=c(seq(min(ul),min(ul), length = (p-1)),kl,seq(max(ul),max(ul), length = (p-1)))#˽ڵ
B=splineDesign(knots=kl, x=ul,ord = p)

xz=cbind(z,B);nx=dim(xz)[2]
xz0=cbind(z,x1);nx0=dim(xz)[2]

qq0=betareg_quasi(xz0,y);betaqq0=qq0$beta

qq2=betareg_quasi(xz,y);betaqq2=qq2$beta
muqq2=exp(xz%*%betaqq2)/(1+exp(xz%*%betaqq2))
logL2=sum(y*log(muqq2)+(1-y)*log(1-muqq2))

qifwi=qif_prop1(xz,y,betaqq2,nk,type="wi")

betawi=qifwi$beta

qifcs=qif_prop1(xz,y,betaqq2,nk,type="cs")

betacs=qifcs$beta

qifcs0=qif_prop1(xz0,y,betaqq0,nk,type="cs")

betacs0=qifcs0$beta

qifar=qif_prop1(xz,y,betaqq2,nk,type="ar")

betaar=qifar$beta

qifar0=qif_prop1(xz0,y,betaqq0,nk,type="ar")

betaar0=qifar0$beta



Hcs=qifcs$H

Har=qifar$H

Hwi=qifwi$H


stdwi=qifwi$sd_est;stdcs=qifcs$sd_est;stdar=qifar$sd_est

pwi=2*(1-pnorm(abs(betawi)/stdwi))

pcs=2*(1-pnorm(abs(betacs)/stdcs))

par=2*(1-pnorm(abs(betaar)/stdar))


round(cbind(betawi,stdwi,pwi,betacs,stdcs,pcs,betaar,stdar,par),4)

round(c(sum(diag(Hwi)[1:6]),sum(diag(Hcs)[1:6]),sum(diag(Har)[1:6])),4)



##################################################################
########## AIC and BIC for AR working correlation##################
##################################################################

Qar=qifar$Q;Qar0=qifar0$Q

BICar=(Qar+log(nsub)*length(betaar))

AICar=(Qar+2*length(betaar))


mucs0=exp(xz0%*%betacs0)/(1+exp(xz0%*%betacs0))

AICar0=(Qar0+2*length(betaar0))

BICar0=(Qar0+log(nsub)*length(betaar0))



c(AICar0,AICar)

c(BICar0,BICar)


xgrid=seq(min(kl),max(kl),len=100)

ul=xgrid;Bg=splineDesign(knots=kl, x=ul,ord = p)


fgar=Bg%*%betaar[-(1:6)];Hfar=Har[-(1:6),-(1:6)];

farstd=diag(Bg%*%Hfar%*%t(Bg));


#######################################################################
##################plot of nonlinear effect for AGE#####################
#######################################################################

plot(xgrid,fgar,type="l",lwd=2,col="red",ylim=c(-2.4,1),xlab="Age",ylab="g(Age)")
lines(xgrid,fgar+1.96*farstd^0.5,lwd=2,col="blue",lty=2)
lines(xgrid,fgar-1.96*farstd^0.5,lwd=2,col="blue",lty=2)










